#ifndef  __OPENGLEAN_EXP_H__
#define  __OPENGLEAN_EXP_H__

/*
 * openglean_exp.h
 *
 * The experimental interfaces to the OpenGLEAN library.
 *
 * You should only include this file if you are using experimental
 * OpenGLEAN features.  The OpenGLEAN project may change or remove
 * any feature in this file, without published warning.  There may
 * not be a corresponding library major version bump to indicate
 * this change, as these are not strictly part of the API.  We
 * appreciate feedback on the utility, desirability, problems, or
 * even pointlessness of features herein, of course.  And, though
 * we discourage depending upon these features in your own releases,
 * we certainly encourage you to try these out to judge their merit.
 *
 * Copyright 2004, the OpenGLEAN Project.
 *
 * Portions copyright (C) 2004, the OpenGLUT project contributors.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS PROJECT BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
 * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */


#ifdef __cplusplus
extern "C" 
{
#endif


/*
 * GLUT API Extension macro definitions -- display mode
 *
 * GLUT_BORDERLESS gives you...a borderless window.
 */
#define GLUT_BORDERLESS                     0x0800

/*
 * OpenGLEAN experimental functions.
 */
OGAPI int OGAPIENTRY glutCreateMenuWindow (
    int parentID, int x, int y, int w, int h
);
OGAPI void OGAPIENTRY glutSetWindowStayOnTop (GLint enable);

/*
 * Allow for conditional compilation of experimental features.
 *
 * XXX Should probably dump these.  There is little clear gain.
 * XXX If you want to know if you should use these features,
 * XXX then you should rely upon explicit compile-time instructions,
 * XXX as passed by the -D option with most C and C++ compilers.
 * XXX If you want to know if these features are actually available,
 * XXX you can either rely upon the API revision, dlopen() semantics,
 * XXX or the glutGetProcAddr() function.  I'll think it over,
 * XXX though, and just leave this note here for now.
 */
#define OPENGLUT_MENUWINDOW
#define OPENGLUT_STAYONTOP

#ifdef __cplusplus
}
#endif

#endif
