/*!
    \file  winsys.c
    \brief The window system/message handling functions.
*/

/*
 * Copyright 2004, 2005 the OpenGLEAN Project.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*
 * Flushes the window system buffers and message queues.
 * If {ogState.XSyncSwitch} is GL_TRUE, we use a heavier "sync"
 * instead of "flush".
 */
static void ogWindowSysFlush (void)
{
#if TARGET_HOST_UNIX_X11
    if (GL_TRUE == ogState.XSyncSwitch)
        XSync (ogDisplay.Display, False);
    else
        XFlush (ogDisplay.Display);
#endif
}
