// basic read and write support for PPM (1 bit black/white), PGM (8 bit gray), PBM (24 bit rgb) formats
//
// by Marcel Lancelle

#ifndef PNM_HEADER_INCLUDED
#define PNM_HEADER_INCLUDED

#include <iostream>

namespace DAVE {

////////////////////////////////////////////////////////////////////////////////////////////
// P5 - PGM (binary 8 bit gray image)
////////////////////////////////////////////////////////////////////////////////////////////

// save 
bool savePGM(std::string fileName, int width, int height, unsigned char* data, int maxIntensity = 255);


//	// sample code to read an image into own buffer
//	int width, height;
//	unsigned char* imgData;
//
//	if loadPGM(fileName, &width, &height, &imgData) {
//		std::cout << "read image successfully" << std::endl;
//
//		...
//
//		delete[] imgData;
//	} else {
//		std::cerr << "Error reading raw data from PGM file " << fileName << std::endl;
//	}

// read image; the necessary memory will be allocated with new, call delete[] when you don't need it any more!
bool loadPGM(std::string fileName, int* width, int* height, unsigned char** data, int* maxIntensity = NULL);

// TODO: as an alternative read method: provide a class PGMFile(std::string fileName) with public members width, height, data, maxIntensity, fileName, with destructor, with save() and saveAs(std::string fileName)

////////////////////////////////////////////////////////////////////////////////////////////

} // namespace DAVE

#endif // PNM_HEADER_INCLUDED
