// TODO: replace this with input device lib


// generic wrapper for a head tracking library
// link the library of your choice in the corresponding subfolder

#ifndef DAVETRACKING_HEADER_INCLUDED
#define DAVETRACKING_HEADER_INCLUDED

namespace DAVE {


class DaveTracking {
  public:
	DaveTracking(const char* address, int port);
	~DaveTracking();

	// each update writes the new values to the variables eyePosLeft, eyePosRight
	// and to the matrices head and joystick
	void update();
	float eyePosLeft[3], eyePosRight[3];

	// matrices in OpenGL order
	// translation values: [12], [13], [14]
	// x-axis: [0], [1], [2]
	// y-axis: [4], [5], [6]
	// z-axis: [8], [9], [10]
	float head[16], joystick[16];
};


} // namespace DAVE

#endif // DAVETRACKING_HEADER_INCLUDED
