// connects stereo tracking of Hyosun with dave tracking (by Marcel)

#include "daveOpticalTracking.h"
#include "Marker3DList.h"
#include "RecognizedTargetList.h"
#include <sstream>
#include <ios>
//#include <map>

//#define DEBUG

namespace davetracking {

/*static*/ OpticalTracking* OpticalTracking::instance = 0;

OpticalTracking::OpticalTracking(const std::string& _ip, const std::string& _port) {
	ok = client.setup(_ip,_port);
}

OpticalTracking::~OpticalTracking() {
    client.close();
}

void OpticalTracking::read() {
#ifdef DEBUG
  std::cout << "Reading Tracking data\n";
#endif
	//  Dave6dposition birdpos[16];
	//  vector<DavetrackingFilter *> *dFilterList;
  bool ret,areOld;

	if (!ok) {
#ifdef DEBUG
	  cout << "setup failed"<<endl;
#endif
	  return;
	}
	ret = client.requestData(All,true);
	if (!ret) {
#ifdef DEBUG
	  cout << "request Data failed"<<endl;
#endif
	  return;
	}
	ret = client.receiveData(areOld);
	if (!ret&&!areOld) {
#ifdef DEBUG
	  cout << "receive Data failed"<<endl;
#endif
	  return;
   } else if(areOld) {
#ifdef DEBUG
	  cout << "receive Data failed, but old data available"<<endl;
#endif
   }

    std::string data = client.getData();
    std::string what;
    std::istringstream sstr(data);

    CGVOpticalTracking::Marker3DList vMarker;
    CGVOpticalTracking::RecognizedTargetList vTarget;
    int len, q,i;
    sstr >> len;
#ifdef DEBUG
    std::cout << "Length: "<<len<<std::endl;
#endif
    while(sstr) {
      sstr >> what;
#ifdef DEBUG
      std::cout << "What: "<<what<<std::endl;
#endif
      if(what=="MarkerPos") {
#ifdef DEBUG
	std::cout << "MarkerPos"<<std::endl;
#endif
        sstr >> vMarker;
      } else if(what=="Target") {
#ifdef DEBUG
	std::cout << "Target"<<std::endl;
#endif
        sstr >> vTarget;
      }
    }

    CGVOpticalTracking::RecognizedTargetList::iterator iter = vTarget.begin();
    while(iter!=vTarget.end()&&iter->name!="glasses") { ++iter; }
    if(iter!=vTarget.end()) {
#ifdef DEBUG
      std::cout << "Setting glass position: ";
#endif
	birdpos[2].x = iter->position.x;
	birdpos[2].y = iter->position.y;
	birdpos[2].z = iter->position.z;
	birdpos[2].rot.v_s = iter->quatRotation.v_s;
	birdpos[2].rot.v_v.x = iter->quatRotation.v_v.x;
	birdpos[2].rot.v_v.y = iter->quatRotation.v_v.y;
	birdpos[2].rot.v_v.z = iter->quatRotation.v_v.z;
//	birdpos[2].ax = -iter->getEulerAngle().z;
//	birdpos[2].ay = iter->getEulerAngle().x;
//	birdpos[2].az = iter->getEulerAngle().y;
#ifdef DEBUG
      std::cout << birdpos[2].x << ',' << birdpos[2].y << ',' << birdpos[2].z << ' ' << birdpos[2].rot.v_s << ':' << birdpos[2].rot.v_v.x << ',' << birdpos[2].rot.v_v.y << ',' << birdpos[2].rot.v_v.z << ' ' << std::endl;
#endif
    }
    iter = vTarget.begin();
    while(iter!=vTarget.end()&&iter->name!="gamepad") { ++iter; }
    if(iter!=vTarget.end()) {
#ifdef DEBUG
      std::cout << "Setting gamepad position: ";
#endif
	birdpos[3].x = iter->position.x;
	birdpos[3].y = iter->position.y;
	birdpos[3].z = iter->position.z;
	birdpos[3].rot.v_s = iter->quatRotation.v_s;
	birdpos[3].rot.v_v.x = iter->quatRotation.v_v.x;
	birdpos[3].rot.v_v.y = iter->quatRotation.v_v.y;
	birdpos[3].rot.v_v.z = iter->quatRotation.v_v.z;
//	birdpos[3].ax = -iter->getEulerAngle().z;
//	birdpos[3].ay = iter->getEulerAngle().x;
//	birdpos[3].az = iter->getEulerAngle().y;
#ifdef DEBUG
      std::cout << birdpos[3].x << ',' << birdpos[3].y << ',' << birdpos[3].z << ' ' << birdpos[3].rot.v_s << ':' << birdpos[3].rot.v_v.x << ',' << birdpos[3].rot.v_v.y << ',' << birdpos[3].rot.v_v.z << ' ' << std::endl;
#endif
    }
}
}


