// connects stereo tracking of Hyosun with dave tracking (by Marcel)

#ifndef DAVETRACKING_OPTICAL_HEADER
#define DAVETRACKING_OPTICAL_HEADER

//#ifdef WIN32
//	#include <windows.h>
//#endif
//#include <iostream>
//#include <cmath>
//#include <vector>
#include "../davetracking/davetrackingTracker.h"
//#include "../davetracking/quaternions.h"
//#include "../t_3DVector.h"
#include "UDPClient.h"

namespace davetracking {
/*
#if 0
class Marker {
 public:
  int   id;
  float x,y,z;
};

class Target {
 public:
  int id;
  float tx,ty,tz;
  float rx,ry,rz;
};
#endif
*/

class OpticalTracking : public DavetrackingTracker
{
// protected:
//  Dave6dposition birdpos[16];
//  vector<DavetrackingFilter *> *dFilterList;

//  /** apply added filters to data. Can throw an exception. */
//  void applyFilters(Dave6dposition &d6, int nr);

 public:
  OpticalTracking(const std::string& _ip, const std::string& _port);
  virtual ~OpticalTracking();

  virtual void read();

  /** Returns the current sensor values from the given device. Valid
      values are 2 (head) and 3 (6D mouse). Before
      using this function you must query the current values from the
      hardware by calling #read. The angles are given in degree.
  */
  //Dave6dposition getPosition(int devicenr);

  /** Adds a filter that preprocesses the data that getPosition returns.
      Every time #read is called, all position data from the bird is
      given to all filters in the order the filters were added.
      @param df The filter object that filters the data.
   */
  //void addFilter(DavetrackingFilter *df);

  private:
          	static OpticalTracking *instance;


public:
  	static OpticalTracking* getInstance(const std::string& _ip, const std::string& _port)
	{
		if (instance==NULL) {
			instance = new OpticalTracking(_ip,_port);
		}
		return instance;
	}

 private:
        UDPClient client;
        bool ok;

};

}
#endif // DAVETRACKING_OPTICAL_HEADER
