#include "../src/DaveConfig.h"
#include <iostream>

int main(char argc, char* argv[]) {
	std::cout << "usage:\ntestDaveConfig [-davecfg config_file] [key=value]\n\nmultiple files or values possible, processed in order." << std::endl;
	std::cout << "The file testDaveConfig1.conf is read afterwards, then one other value is set manually." << std::endl;

	DAVE::DaveConfig conf;

	// use command line to define some values
	conf.processCmdLineArguments(argc, argv);

	// read a config file
	conf.processConfigFile("testDaveConfig1.conf");

	// manually add a value
	conf.processLine("ManuallyAddedValue=42.123abc");

	conf.printAll();

	std::cout << "String value of the manually added one: " << conf.getString("ManuallyAddedValue") << std::endl;
	std::cout << "Int value of the manually added one   : " << conf.getInt("ManuallyAddedValue") << std::endl;
	std::cout << "Double value of the manually added one: " << conf.getDouble("ManuallyAddedValue") << std::endl;

	std::cout << "String value of non-existing key: " << conf.getString("ManuallyAddedValueNONEXISTANT") << std::endl;
	std::cout << "Int value of non-existing key   : " << conf.getInt("ManuallyAddedValueNONEXISTANT") << std::endl;

	std::cout << "hasKey(\"test1\") : " << conf.hasKey("test1") << std::endl;
	std::cout << "hasKey(\"test1234\") : " << conf.hasKey("test1234") << std::endl;

	return 0;
}
