#ifdef WIN32
#include <windows.h>
#else // WIN32
#endif // WIN32

#include "../src/DaveNetwork.h"

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>

int main(int argc, char* argv[]) {
	if (argc < 3) {
		std::cout << "udp test (multicast or not), usage:" << std::endl;
		std::cout << " server: testDaveNetwork address port message" << std::endl;
		std::cout << " client: testDaveNetwork address port" << std::endl;
	}

	if (argc == 4) {
		// server
		std::cout << "server" << std::endl;

		DAVE::DaveNetworkServerUDP server;
		server.addClient(argv[1], atoi(argv[2]));

		while (1) {
			server.sendStatusToClients(argv[3], strlen(argv[3])+1);

char c[2] = {0,0};
for (c[0]='1'; c[0]<='9'; c[0]++)
	server.sendStatusToClients(c, 2);

			#ifdef WIN32
			Sleep(1000);
			#else // WIN32
			sleep(1);
			#endif // WIN32
		}

		return 0;
	}

	if (argc == 3) {
		// client
		std::cout << "client" << std::endl;

		DAVE::DaveNetworkClientUDP client(argv[1], atoi(argv[2]));
		char buffer[200];
		while (1) {
			int count = 0;
			int recvNum;
			do {
				recvNum = client.receiveStatusFromServer(buffer, 200);
				if (recvNum) {
					std::cout << "message #" << count << ": " << buffer << std::endl;
				} else {
					std::cout << "no message" << std::endl;
				}
			} while (recvNum && (count++ < 50));

			#ifdef WIN32
			Sleep(2000);
			#else // WIN32
			sleep(2);
			#endif // WIN32
		}
	}

	return 0;
}
