// Windows: link with Ws2_32.lib

#ifdef WIN32
#include <windows.h> // for Sleep()
#endif // WIN32

#include "../src/DaveTracking.h"

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>

int main(char argc, char* argv[]) {
	if (argc < 3) {
		std::cout << "multicast udp test, usage:" << std::endl;
		std::cout << " server: testDaveNetwork address port message" << std::endl;
		std::cout << " client: testDaveNetwork address port" << std::endl;
	}

	if (argc == 3) {
		DAVE::DaveTracking tracking(argv[1], atoi(argv[2]));

		while (1) {
			tracking.update();

			std::cout << "eye positions: "
				<< tracking.eyePosLeft[0] << ", " << tracking.eyePosLeft[1] << ", " << tracking.eyePosLeft[2] << "    "
				<< tracking.eyePosRight[0] << ", " << tracking.eyePosRight[1] << ", " << tracking.eyePosRight[2] << std::endl;

			std::cout << "eye positions: "
				<< tracking.eyePosLeft[0] << ", " << tracking.eyePosLeft[1] << ", " << tracking.eyePosLeft[2] << "    "
				<< tracking.eyePosRight[0] << ", " << tracking.eyePosRight[1] << ", " << tracking.eyePosRight[2] << std::endl;

			std::cout << "head matrix: ";
			for (int i=0; i<16; i++) std::cout << tracking.head[i] << " ";
			std::cout << std::endl;

			std::cout << "joystick matrix: ";
			for (int i=0; i<16; i++) std::cout << tracking.joystick[i] << " ";
			std::cout << std::endl;

			#ifdef WIN32
			Sleep(1000);
			#else // WIN32
			sleep(1);
			#endif // WIN32
		}
	}

	return 0;
}
