/*
 * class for (some) millisecond precise time measurement in windows
 * using multimedia timer function timeGetTime()
 *
 * include library winmm
 *
 * by Marcel Lancelle
 */

#ifndef DIFFTIME_HEADER_INCLUDED
#define DIFFTIME_HEADER_INCLUDED

#ifdef WIN32
#include <windows.h>
#include <mmsystem.h>
#else
#include <sys/time.h>
#endif

class DiffTime {
  public:
	// starts time measurement
	void start();

	// returns time since start
	float getSeconds();

  protected:
#ifdef WIN32
	DWORD startTime;
#else
	timeval startTime;
#endif
};

#endif // DIFFTIME_HEADER_INCLUDED
