#define USE_WIN




#include "SDL_joystick.h"

#include <conio.h>
#include <stdio.h>
#include <iostream>


#ifdef USE_WIN
#include <windows.h>
#endif // USE_WIN

#include <vector>

std::vector<SDL_Joystick*> joysticks;

int main(char** argv, int argc) {
	SDL_JoystickInit();

	// number of joysticks
	printf("You've got %i joystick(s).\n", SDL_NumJoysticks());

	if (SDL_NumJoysticks() < 1) return 0;

	for (int i=0; i<SDL_NumJoysticks(); i++) {
		// name of joysticks
		printf("name of joystick %i: %s\n", i, SDL_JoystickName(i));

		SDL_Joystick* jp = SDL_JoystickOpen(i);
		if (jp) {
			printf("joystick %i opened\n", i);
			joysticks.push_back(jp);
		} else {
			printf("joystick %i couldn't be opened\n", i);
		}
	}


	for (std::vector<SDL_Joystick*>::iterator j=joysticks.begin(); j!=joysticks.end(); ++j) {
		printf("axes: %i    buttons: %i\n", SDL_JoystickNumAxes(*j), SDL_JoystickNumButtons(*j));
	}


	char key = 0;
	while (key != 27) {

#ifdef USE_WIN
		Sleep(50);
#endif // USE_WIN

		SDL_JoystickUpdate();

		for (std::vector<SDL_Joystick*>::iterator j=joysticks.begin(); j!=joysticks.end(); ++j) {
			printf("a "); // axes
			for (int na=0; na<SDL_JoystickNumAxes(*j); na++)
				printf("%.2f ", SDL_JoystickGetAxisF(*j, na));
			printf("b "); // buttons
			for (int nb=0; nb<SDL_JoystickNumButtons(*j); nb++)
				printf("%i ", SDL_JoystickGetButton(*j, nb));
			printf("h "); // hats
			for (int nh=0; nh<SDL_JoystickNumHats(*j); nh++)
				printf("%i ", SDL_JoystickGetHat(*j, nh));
		}

		printf("  \r");

		if (kbhit()) {key = getch();}
	}


	for (std::vector<SDL_Joystick*>::iterator j=joysticks.begin(); j!=joysticks.end(); ++j) {
		SDL_JoystickClose(*j);
	}

	printf("\nall joysticks closed\n");

	return 0;
}

